Apache log4cxx: ErrorHandler Class Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# ErrorHandler Class Reference

Inherits OptionHandler.

Inherited by OnlyOnceErrorHandler`[virtual]`, and FallbackErrorHandler`[virtual]`.

List of all members.

## Detailed Description

Appenders may delegate their error handling to `ErrorHandlers`.

Error handling is a particularly tedious to get right because by definition errors are hard to predict and to reproduce.

Please take the time to contact the author in case you discover that errors are not properly handled. You are most welcome to suggest new error handling policies or criticize existing policies.

## Public Member Functions
virtual | ~ErrorHandler ()
virtual void | setLogger (const LoggerPtr &logger)=0
| Add a reference to a logger to which the failing appender might be attached to.
virtual void | error (const LogString &message, const std::exception &e, int errorCode) const =0
| Equivalent to the error(const String&, helpers::Exception&, int, spi::LoggingEvent&) with the the event parameteter set to null.
virtual void | error (const LogString &message) const =0
| This method is normally used to just print the error message passed as a parameter.
virtual void | error (const LogString &message, const std::exception &e, int errorCode, const LoggingEventPtr &event) const =0
| This method is invoked to handle the error.
virtual void | setAppender (const AppenderPtr &appender)=0
| Set the appender for which errors are handled.
virtual void | setBackupAppender (const AppenderPtr &appender)=0
| Set the appender to fallback upon in case of failure.

## Constructor & Destructor Documentation

virtual ~ErrorHandler | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

virtual void error | ( | const LogString & | message,
|  | const std::exception & | e,
|  | int | errorCode,
|  | const LoggingEventPtr & | event
| ) | const`[pure virtual]`

  | This method is invoked to handle the error. Parameters:
  | message | The message assoicated with the error.
  | e | The Exption that was thrown when the error occured.
  | errorCode | The error code associated with the error.
  | event | The logging event that the failing appender is asked to log.
Implemented in OnlyOnceErrorHandler, and FallbackErrorHandler.

virtual void error | ( | const LogString & | message | ) | const`[pure virtual]`

| This method is normally used to just print the error message passed as a parameter. Implemented in OnlyOnceErrorHandler, and FallbackErrorHandler.

virtual void error | ( | const LogString & | message,
|  | const std::exception & | e,
|  | int | errorCode
| ) | const`[pure virtual]`

| Equivalent to the error(const String&, helpers::Exception&, int, spi::LoggingEvent&) with the the event parameteter set to null. Implemented in OnlyOnceErrorHandler, and FallbackErrorHandler.

virtual void setAppender | ( | const AppenderPtr & | appender | ) | `[pure virtual]`

| Set the appender for which errors are handled. This method is usually called when the error handler is configured. Implemented in OnlyOnceErrorHandler, and FallbackErrorHandler.

virtual void setBackupAppender | ( | const AppenderPtr & | appender | ) | `[pure virtual]`

| Set the appender to fallback upon in case of failure. Implemented in OnlyOnceErrorHandler, and FallbackErrorHandler.

virtual void setLogger | ( | const LoggerPtr & | logger | ) | `[pure virtual]`

  | Add a reference to a logger to which the failing appender might be attached to. The failing appender will be searched and replaced only in the loggers you add through this method. Parameters:
  | logger | One of the loggers that will be searched for the failing appender in view of replacement.
Implemented in OnlyOnceErrorHandler, and FallbackErrorHandler.

The documentation for this class was generated from the following file:

- errorhandler.h